//+------------------------------------------------------------------+
//|                                                   Kotir_Out.mq4  |
//|       EViews                          |
//|     29.08.2011                                           |
//+------------------------------------------------------------------+
//---    
#property indicator_chart_window
//--- -   
#property indicator_buffers            1
//---   
#property indicator_color1             Red      //       
//---   
#property indicator_width1             2
//---  
extern   int      Number_Bars=100;     // - 
extern   string   DateTime_begin    =  "2011.01.01 00:00";
extern   string   DateTime_end      =  "2011.01.01 00:00";
//---  
//---  
double   Quotes[];         //  -  
int      Quotes_handle;    //    Quotes
int      i;                //   
//---      EViews
string   fileQuotes;       //    
//+------------------------------------------------------------------+
//|Indicator initialization function                                 |
//+------------------------------------------------------------------+
int init()
  {
//--- -  
   IndicatorBuffers(1);
//---   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,0);
   SetIndexDrawBegin(0,Number_Bars);

//---     
   SetIndexBuffer(0,Quotes);  //  

//---   
   SetIndexEmptyValue(0,0.0);
//---  
   IndicatorShortName("Forecast");
//---       EViews
   fileQuotes="kotir.txt";   //    
   int       N_bars_begin   =  0;
   int       N_bars_end     =  0;

   datetime  var_DT_begin   =  0;
   datetime  var_DT_end     =  0;
   bool      exact          =  false;
//---
//---      EViews
   Quotes_handle=FileOpen(fileQuotes,FILE_CSV|FILE_WRITE,',');
//---  
   if(Quotes_handle<1)
     {
      Print("    ",fileQuotes,"  #",GetLastError());
      return(0);
     }
   FileWrite(Quotes_handle,"DATE","kotir");  // 
//---    
//---     
   var_DT_begin =  StrToTime(DateTime_begin);
   var_DT_end   =  StrToTime(DateTime_end);

   if(var_DT_begin!=var_DT_end)
     {
      N_bars_begin=iBarShift(NULL,Period(),var_DT_begin,exact);
      N_bars_end=iBarShift(NULL,Period(),var_DT_end,exact);
      Number_Bars=N_bars_begin-N_bars_end;

      Print("Number_Bars = ",Number_Bars,
            ", N_bars_end = ",N_bars_end,
            ", N_bars_begin = ",N_bars_begin);

      for(i=N_bars_begin; i>=N_bars_end; i--)
        {
         FileWrite(Quotes_handle,
                   TimeToStr(iTime(Symbol(),Period(),i)),
                   iOpen(Symbol(),Period(),i));
        }
     }
   else
     {
      for(i=Number_Bars-1; i>=0; i--)
        {
         FileWrite(Quotes_handle,
                   TimeToStr(iTime(Symbol(),Period(),i)),
                   iOpen(Symbol(),Period(),i));
        }
     }
// ---  
   FileWrite(Quotes_handle, " ", 0);   //   
   FileClose(Quotes_handle);                  //    
   Comment("   c   =",Number_Bars+1);
//---   Init()
   return(0);
  }
//+------------------------------------------------------------------+
//| Indicator start function                                         |
//+------------------------------------------------------------------+
int start()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---    
   Comment("                                                     ");
//----
   return(0);
  }
//+------------------------------------------------------------------+